`timescale 1ns/1ps

`define C_S_AXI_DATA_WIDTH 32
`define C_S_AXI_ADDR_WIDTH 32
   
module test_i2c_ip_top 
    (
    clk_50M,
    rst_n,
    scl,
    sda,
    wr_error_flag,
    cstate_f,
    interupt
);
    
    input			clk_50M;
    input			rst_n;
    inout			scl;
    inout			sda;
    output          wr_error_flag;
    
    output          cstate_f;
    output          interupt;
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
/*reg/wire 															*/
 
 wire    [`C_S_AXI_ADDR_WIDTH - 1:0]  S_AXI_AWADDR;
 wire                                 S_AXI_AWVALID;
 wire                                 S_AXI_AWREADY;
 wire    [`C_S_AXI_DATA_WIDTH-1:0]    S_AXI_WDATA;
 wire    [`C_S_AXI_DATA_WIDTH/8-1:0]  S_AXI_WSTRB;
 wire                                 S_AXI_WVALID;
 wire                                 S_AXI_WREADY;
 wire    [1:0]                        S_AXI_BRESP;
 wire                                 S_AXI_BVALID;
 wire                                 S_AXI_BREADY;
 wire    [`C_S_AXI_ADDR_WIDTH - 1:0]  S_AXI_ARADDR;
 wire                                 S_AXI_ARVALID;
 wire                                 S_AXI_ARREADY;
 wire    [`C_S_AXI_DATA_WIDTH-1:0]    S_AXI_RDATA;
 wire    [1:0]                        S_AXI_RRESP;
 wire                                 S_AXI_RVALID;
 wire                                 S_AXI_RREADY;
 wire								  AXI_INTA_O;
 
 wire                                 sys_clk;


 master_axi_lite_iic 	u_master_axi_lite_iic
  		(
  		.S_AXI_ACLK         ( clk_50M                	),
        .S_AXI_ARESETN      ( rst_n            			),
        .S_AXI_AWADDR       ( S_AXI_AWADDR              ),
        .S_AXI_AWVALID      ( S_AXI_AWVALID             ),
        .S_AXI_AWREADY      ( S_AXI_AWREADY             ),
        .S_AXI_WDATA        ( S_AXI_WDATA               ),
        .S_AXI_WSTRB        ( S_AXI_WSTRB               ),
        .S_AXI_WVALID       ( S_AXI_WVALID              ),
        .S_AXI_WREADY       ( S_AXI_WREADY              ),
        .S_AXI_BRESP        ( S_AXI_BRESP               ),
        .S_AXI_BVALID       ( S_AXI_BVALID              ),
        .S_AXI_BREADY       ( S_AXI_BREADY              ),
        .S_AXI_ARADDR       ( S_AXI_ARADDR              ),
        .S_AXI_ARVALID      ( S_AXI_ARVALID             ),
        .S_AXI_ARREADY      ( S_AXI_ARREADY             ),
        .S_AXI_RDATA        ( S_AXI_RDATA               ),
        .S_AXI_RRESP        ( S_AXI_RRESP               ),
        .S_AXI_RVALID       ( S_AXI_RVALID              ),
        .S_AXI_RREADY       ( S_AXI_RREADY              ),
        .cstate_flag        ( cstate_f                     ),
        .error_flag         ( wr_error_flag             )
  );

  // Instantiate the DUT
    I2C_Master_Top_SIP   		u_i2c (
        .S_AXI_ACLK         ( clk_50M               	 ),
        .S_AXI_ARESETN      ( rst_n             		),
        .S_AXI_AWADDR       ( S_AXI_AWADDR              ),
        .S_AXI_AWVALID      ( S_AXI_AWVALID             ),
        .S_AXI_AWREADY      ( S_AXI_AWREADY             ),
        .S_AXI_WDATA        ( S_AXI_WDATA               ),
        .S_AXI_WSTRB        ( S_AXI_WSTRB               ),
        .S_AXI_WVALID       ( S_AXI_WVALID              ),
        .S_AXI_WREADY       ( S_AXI_WREADY              ),
        .S_AXI_BRESP        ( S_AXI_BRESP               ),
        .S_AXI_BVALID       ( S_AXI_BVALID              ),
        .S_AXI_BREADY       ( S_AXI_BREADY              ),
        .S_AXI_ARADDR       ( S_AXI_ARADDR              ),
        .S_AXI_ARVALID      ( S_AXI_ARVALID             ),
        .S_AXI_ARREADY      ( S_AXI_ARREADY             ),
        .S_AXI_RDATA        ( S_AXI_RDATA               ),
        .S_AXI_RRESP        ( S_AXI_RRESP               ),
        .S_AXI_RVALID       ( S_AXI_RVALID              ),
        .S_AXI_RREADY       ( S_AXI_RREADY              ),
        .AXI_INTA_O         ( AXI_INTA_O                ),
        .SCL                ( scl                       ),
        .SDA                ( sda                       )
        );               
    

endmodule
  

