
`timescale 1ns/1ps

module tb;

//input
    reg     clk;
    reg     rst;

//output
    wire    scl;
    wire    sda;
    wire    wr_error_flag;
    wire    cstate_f;
    wire    interupt;

    pullup p1(scl); // pullup scl line
    pullup p2(sda); // pullup sda line

    GSR GSR(.GSRI(1'b1));
    
    test_i2c_ip_top ip_tst  (
        .clk_50M(clk),
        .rst_n(rst),
        .scl(scl),
        .sda(sda),
        .wr_error_flag(wr_error_flag),
        .cstate_f(cstate_f)
    );

    i2c_slave_top u_slave (
        .clk(clk),
        .rst(rst),
        .scl(scl),
        .sda(sda),
        .int_o(interupt)
    );

    initial begin
        clk=0;
        forever #10 clk=~clk;
    end

    initial begin
        $fsdbDumpfile("i2c.fsdb");
        $fsdbDumpvars;
    end

    integer fp_w;
	initial begin
        fp_w = $fopen("tmp.avc", "w");
        #3;
        forever
        #10 $fwrite(fp_w,"R1 ts1 %d%d;\n",clk,rst);
    end


    initial begin
        rst=1;
        #1000;
        rst=0;
        #100;
        rst=1;
        #500000;

        $fclose(fp_w);
        $finish;
    end

endmodule
